<?php
use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfArrayOfCotisationData ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfArrayOfCotisationData
 * @subpackage Arrays
 */
class ArrayOfArrayOfCotisationData extends AbstractStructArrayBase
{
    /**
     * The ArrayOfCotisationData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var ArrayOfCotisationData[]
     */
    public $ArrayOfCotisationData;
    /**
     * Constructor method for ArrayOfArrayOfCotisationData
     * @uses ArrayOfArrayOfCotisationData::setArrayOfCotisationData()
     * @param ArrayOfCotisationData[] $arrayOfCotisationData
     */
    public function __construct(array $arrayOfCotisationData = array())
    {
        $this
            ->setArrayOfCotisationData($arrayOfCotisationData);
    }
    /**
     * Get ArrayOfCotisationData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return ArrayOfCotisationData[]|null
     */
    public function getArrayOfCotisationData()
    {
        return isset($this->ArrayOfCotisationData) ? $this->ArrayOfCotisationData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setArrayOfCotisationData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setArrayOfCotisationData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateArrayOfCotisationDataForArrayConstraintsFromSetArrayOfCotisationData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfArrayOfCotisationDataArrayOfCotisationDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfArrayOfCotisationDataArrayOfCotisationDataItem instanceof ArrayOfCotisationData) {
                $invalidValues[] = is_object($arrayOfArrayOfCotisationDataArrayOfCotisationDataItem) ? get_class($arrayOfArrayOfCotisationDataArrayOfCotisationDataItem) : sprintf('%s(%s)', gettype($arrayOfArrayOfCotisationDataArrayOfCotisationDataItem), var_export($arrayOfArrayOfCotisationDataArrayOfCotisationDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ArrayOfCotisationData property can only contain items of type ArrayOfCotisationData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ArrayOfCotisationData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param ArrayOfCotisationData[] $arrayOfCotisationData
     * @return ArrayOfArrayOfCotisationData
     */
    public function setArrayOfCotisationData(array $arrayOfCotisationData = array())
    {
        // validation for constraint: array
        if ('' !== ($arrayOfCotisationDataArrayErrorMessage = self::validateArrayOfCotisationDataForArrayConstraintsFromSetArrayOfCotisationData($arrayOfCotisationData))) {
            throw new \InvalidArgumentException($arrayOfCotisationDataArrayErrorMessage, __LINE__);
        }
        if (is_null($arrayOfCotisationData) || (is_array($arrayOfCotisationData) && empty($arrayOfCotisationData))) {
            unset($this->ArrayOfCotisationData);
        } else {
            $this->ArrayOfCotisationData = $arrayOfCotisationData;
        }
        return $this;
    }
    /**
     * Add item to ArrayOfCotisationData value
     * @throws \InvalidArgumentException
     * @param ArrayOfCotisationData $item
     * @return ArrayOfArrayOfCotisationData
     */
    public function addToArrayOfCotisationData(ArrayOfCotisationData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof ArrayOfCotisationData) {
            throw new \InvalidArgumentException(sprintf('The ArrayOfCotisationData property can only contain items of type ArrayOfCotisationData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ArrayOfCotisationData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return ArrayOfCotisationData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return ArrayOfCotisationData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return ArrayOfCotisationData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return ArrayOfCotisationData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return ArrayOfCotisationData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ArrayOfCotisationData
     */
    public function getAttributeName()
    {
        return 'ArrayOfCotisationData';
    }
}
