<?php
use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAssureData ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAssureData
 * @subpackage Arrays
 */
class ArrayOfAssureData extends AbstractStructArrayBase
{
    /**
     * The AssureData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var AssureData[]
     */
    public $AssureData;
    /**
     * Constructor method for ArrayOfAssureData
     * @uses ArrayOfAssureData::setAssureData()
     * @param AssureData[] $assureData
     */
    public function __construct(array $assureData = array())
    {
        $this
            ->setAssureData($assureData);
    }
    /**
     * Get AssureData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return AssureData[]|null
     */
    public function getAssureData()
    {
        return isset($this->AssureData) ? $this->AssureData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAssureData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAssureData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAssureDataForArrayConstraintsFromSetAssureData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAssureDataAssureDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfAssureDataAssureDataItem instanceof AssureData) {
                $invalidValues[] = is_object($arrayOfAssureDataAssureDataItem) ? get_class($arrayOfAssureDataAssureDataItem) : sprintf('%s(%s)', gettype($arrayOfAssureDataAssureDataItem), var_export($arrayOfAssureDataAssureDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AssureData property can only contain items of type AssureData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AssureData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param AssureData[] $assureData
     * @return ArrayOfAssureData
     */
    public function setAssureData(array $assureData = array())
    {
        // validation for constraint: array
        if ('' !== ($assureDataArrayErrorMessage = self::validateAssureDataForArrayConstraintsFromSetAssureData($assureData))) {
            throw new \InvalidArgumentException($assureDataArrayErrorMessage, __LINE__);
        }
        if (is_null($assureData) || (is_array($assureData) && empty($assureData))) {
            unset($this->AssureData);
        } else {
            $this->AssureData = $assureData;
        }
        return $this;
    }
    /**
     * Add item to AssureData value
     * @throws \InvalidArgumentException
     * @param AssureData $item
     * @return ArrayOfAssureData
     */
    public function addToAssureData(AssureData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof AssureData) {
            throw new \InvalidArgumentException(sprintf('The AssureData property can only contain items of type AssureData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AssureData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return AssureData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return AssureData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return AssureData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return AssureData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return AssureData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AssureData
     */
    public function getAttributeName()
    {
        return 'AssureData';
    }
}
