<?php
use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCotisationData ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCotisationData
 * @subpackage Arrays
 */
class ArrayOfCotisationData extends AbstractStructArrayBase
{
    /**
     * The CotisationData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var CotisationData[]
     */
    public $CotisationData;
    /**
     * Constructor method for ArrayOfCotisationData
     * @uses ArrayOfCotisationData::setCotisationData()
     * @param CotisationData[] $cotisationData
     */
    public function __construct(array $cotisationData = array())
    {
        $this
            ->setCotisationData($cotisationData);
    }
    /**
     * Get CotisationData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return CotisationData[]|null
     */
    public function getCotisationData()
    {
        return isset($this->CotisationData) ? $this->CotisationData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCotisationData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCotisationData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCotisationDataForArrayConstraintsFromSetCotisationData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCotisationDataCotisationDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfCotisationDataCotisationDataItem instanceof CotisationData) {
                $invalidValues[] = is_object($arrayOfCotisationDataCotisationDataItem) ? get_class($arrayOfCotisationDataCotisationDataItem) : sprintf('%s(%s)', gettype($arrayOfCotisationDataCotisationDataItem), var_export($arrayOfCotisationDataCotisationDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CotisationData property can only contain items of type CotisationData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CotisationData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param CotisationData[] $cotisationData
     * @return ArrayOfCotisationData
     */
    public function setCotisationData(array $cotisationData = array())
    {
        // validation for constraint: array
        if ('' !== ($cotisationDataArrayErrorMessage = self::validateCotisationDataForArrayConstraintsFromSetCotisationData($cotisationData))) {
            throw new \InvalidArgumentException($cotisationDataArrayErrorMessage, __LINE__);
        }
        if (is_null($cotisationData) || (is_array($cotisationData) && empty($cotisationData))) {
            unset($this->CotisationData);
        } else {
            $this->CotisationData = $cotisationData;
        }
        return $this;
    }
    /**
     * Add item to CotisationData value
     * @throws \InvalidArgumentException
     * @param CotisationData $item
     * @return ArrayOfCotisationData
     */
    public function addToCotisationData(CotisationData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof CotisationData) {
            throw new \InvalidArgumentException(sprintf('The CotisationData property can only contain items of type CotisationData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CotisationData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return CotisationData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return CotisationData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return CotisationData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return CotisationData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return CotisationData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CotisationData
     */
    public function getAttributeName()
    {
        return 'CotisationData';
    }
}
