<?php
use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCotisationRow ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCotisationRow
 * @subpackage Arrays
 */
class ArrayOfCotisationRow extends AbstractStructArrayBase
{
    /**
     * The CotisationRow
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var CotisationRow[]
     */
    public $CotisationRow;
    /**
     * Constructor method for ArrayOfCotisationRow
     * @uses ArrayOfCotisationRow::setCotisationRow()
     * @param CotisationRow[] $cotisationRow
     */
    public function __construct(array $cotisationRow = array())
    {
        $this
            ->setCotisationRow($cotisationRow);
    }
    /**
     * Get CotisationRow value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return CotisationRow[]|null
     */
    public function getCotisationRow()
    {
        return isset($this->CotisationRow) ? $this->CotisationRow : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCotisationRow method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCotisationRow method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCotisationRowForArrayConstraintsFromSetCotisationRow(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCotisationRowCotisationRowItem) {
            // validation for constraint: itemType
            if (!$arrayOfCotisationRowCotisationRowItem instanceof CotisationRow) {
                $invalidValues[] = is_object($arrayOfCotisationRowCotisationRowItem) ? get_class($arrayOfCotisationRowCotisationRowItem) : sprintf('%s(%s)', gettype($arrayOfCotisationRowCotisationRowItem), var_export($arrayOfCotisationRowCotisationRowItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CotisationRow property can only contain items of type CotisationRow, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CotisationRow value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param CotisationRow[] $cotisationRow
     * @return ArrayOfCotisationRow
     */
    public function setCotisationRow(array $cotisationRow = array())
    {
        // validation for constraint: array
        if ('' !== ($cotisationRowArrayErrorMessage = self::validateCotisationRowForArrayConstraintsFromSetCotisationRow($cotisationRow))) {
            throw new \InvalidArgumentException($cotisationRowArrayErrorMessage, __LINE__);
        }
        if (is_null($cotisationRow) || (is_array($cotisationRow) && empty($cotisationRow))) {
            unset($this->CotisationRow);
        } else {
            $this->CotisationRow = $cotisationRow;
        }
        return $this;
    }
    /**
     * Add item to CotisationRow value
     * @throws \InvalidArgumentException
     * @param CotisationRow $item
     * @return ArrayOfCotisationRow
     */
    public function addToCotisationRow(CotisationRow $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof CotisationRow) {
            throw new \InvalidArgumentException(sprintf('The CotisationRow property can only contain items of type CotisationRow, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CotisationRow[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return CotisationRow|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return CotisationRow|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return CotisationRow|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return CotisationRow|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return CotisationRow|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CotisationRow
     */
    public function getAttributeName()
    {
        return 'CotisationRow';
    }
}
