<?php
use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDossierSimulation ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDossierSimulation
 * @subpackage Arrays
 */
class ArrayOfDossierSimulation extends AbstractStructArrayBase
{
    /**
     * The DossierSimulation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var DossierSimulation[]
     */
    public $DossierSimulation;
    /**
     * Constructor method for ArrayOfDossierSimulation
     * @uses ArrayOfDossierSimulation::setDossierSimulation()
     * @param DossierSimulation[] $dossierSimulation
     */
    public function __construct(array $dossierSimulation = array())
    {
        $this
            ->setDossierSimulation($dossierSimulation);
    }
    /**
     * Get DossierSimulation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return DossierSimulation[]|null
     */
    public function getDossierSimulation()
    {
        return isset($this->DossierSimulation) ? $this->DossierSimulation : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDossierSimulation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDossierSimulation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDossierSimulationForArrayConstraintsFromSetDossierSimulation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDossierSimulationDossierSimulationItem) {
            // validation for constraint: itemType
            if (!$arrayOfDossierSimulationDossierSimulationItem instanceof DossierSimulation) {
                $invalidValues[] = is_object($arrayOfDossierSimulationDossierSimulationItem) ? get_class($arrayOfDossierSimulationDossierSimulationItem) : sprintf('%s(%s)', gettype($arrayOfDossierSimulationDossierSimulationItem), var_export($arrayOfDossierSimulationDossierSimulationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DossierSimulation property can only contain items of type DossierSimulation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DossierSimulation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param DossierSimulation[] $dossierSimulation
     * @return ArrayOfDossierSimulation
     */
    public function setDossierSimulation(array $dossierSimulation = array())
    {
        // validation for constraint: array
        if ('' !== ($dossierSimulationArrayErrorMessage = self::validateDossierSimulationForArrayConstraintsFromSetDossierSimulation($dossierSimulation))) {
            throw new \InvalidArgumentException($dossierSimulationArrayErrorMessage, __LINE__);
        }
        if (is_null($dossierSimulation) || (is_array($dossierSimulation) && empty($dossierSimulation))) {
            unset($this->DossierSimulation);
        } else {
            $this->DossierSimulation = $dossierSimulation;
        }
        return $this;
    }
    /**
     * Add item to DossierSimulation value
     * @throws \InvalidArgumentException
     * @param DossierSimulation $item
     * @return ArrayOfDossierSimulation
     */
    public function addToDossierSimulation(DossierSimulation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof DossierSimulation) {
            throw new \InvalidArgumentException(sprintf('The DossierSimulation property can only contain items of type DossierSimulation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DossierSimulation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return DossierSimulation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return DossierSimulation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return DossierSimulation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return DossierSimulation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return DossierSimulation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DossierSimulation
     */
    public function getAttributeName()
    {
        return 'DossierSimulation';
    }
}
