<?php
use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFormaliteMedicaleData ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFormaliteMedicaleData
 * @subpackage Arrays
 */
class ArrayOfFormaliteMedicaleData extends AbstractStructArrayBase
{
    /**
     * The FormaliteMedicaleData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var FormaliteMedicaleData[]
     */
    public $FormaliteMedicaleData;
    /**
     * Constructor method for ArrayOfFormaliteMedicaleData
     * @uses ArrayOfFormaliteMedicaleData::setFormaliteMedicaleData()
     * @param FormaliteMedicaleData[] $formaliteMedicaleData
     */
    public function __construct(array $formaliteMedicaleData = array())
    {
        $this
            ->setFormaliteMedicaleData($formaliteMedicaleData);
    }
    /**
     * Get FormaliteMedicaleData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return FormaliteMedicaleData[]|null
     */
    public function getFormaliteMedicaleData()
    {
        return isset($this->FormaliteMedicaleData) ? $this->FormaliteMedicaleData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFormaliteMedicaleData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFormaliteMedicaleData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFormaliteMedicaleDataForArrayConstraintsFromSetFormaliteMedicaleData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFormaliteMedicaleDataFormaliteMedicaleDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfFormaliteMedicaleDataFormaliteMedicaleDataItem instanceof FormaliteMedicaleData) {
                $invalidValues[] = is_object($arrayOfFormaliteMedicaleDataFormaliteMedicaleDataItem) ? get_class($arrayOfFormaliteMedicaleDataFormaliteMedicaleDataItem) : sprintf('%s(%s)', gettype($arrayOfFormaliteMedicaleDataFormaliteMedicaleDataItem), var_export($arrayOfFormaliteMedicaleDataFormaliteMedicaleDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FormaliteMedicaleData property can only contain items of type FormaliteMedicaleData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FormaliteMedicaleData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param FormaliteMedicaleData[] $formaliteMedicaleData
     * @return ArrayOfFormaliteMedicaleData
     */
    public function setFormaliteMedicaleData(array $formaliteMedicaleData = array())
    {
        // validation for constraint: array
        if ('' !== ($formaliteMedicaleDataArrayErrorMessage = self::validateFormaliteMedicaleDataForArrayConstraintsFromSetFormaliteMedicaleData($formaliteMedicaleData))) {
            throw new \InvalidArgumentException($formaliteMedicaleDataArrayErrorMessage, __LINE__);
        }
        if (is_null($formaliteMedicaleData) || (is_array($formaliteMedicaleData) && empty($formaliteMedicaleData))) {
            unset($this->FormaliteMedicaleData);
        } else {
            $this->FormaliteMedicaleData = $formaliteMedicaleData;
        }
        return $this;
    }
    /**
     * Add item to FormaliteMedicaleData value
     * @throws \InvalidArgumentException
     * @param FormaliteMedicaleData $item
     * @return ArrayOfFormaliteMedicaleData
     */
    public function addToFormaliteMedicaleData(FormaliteMedicaleData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof FormaliteMedicaleData) {
            throw new \InvalidArgumentException(sprintf('The FormaliteMedicaleData property can only contain items of type FormaliteMedicaleData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FormaliteMedicaleData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return FormaliteMedicaleData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return FormaliteMedicaleData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return FormaliteMedicaleData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return FormaliteMedicaleData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return FormaliteMedicaleData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FormaliteMedicaleData
     */
    public function getAttributeName()
    {
        return 'FormaliteMedicaleData';
    }
}
