<?php
use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMontantTotalSouscriptionData ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfMontantTotalSouscriptionData
 * @subpackage Arrays
 */
class ArrayOfMontantTotalSouscriptionData extends AbstractStructArrayBase
{
    /**
     * The MontantTotalSouscriptionData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var MontantTotalSouscriptionData[]
     */
    public $MontantTotalSouscriptionData;
    /**
     * Constructor method for ArrayOfMontantTotalSouscriptionData
     * @uses ArrayOfMontantTotalSouscriptionData::setMontantTotalSouscriptionData()
     * @param MontantTotalSouscriptionData[] $montantTotalSouscriptionData
     */
    public function __construct(array $montantTotalSouscriptionData = array())
    {
        $this
            ->setMontantTotalSouscriptionData($montantTotalSouscriptionData);
    }
    /**
     * Get MontantTotalSouscriptionData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return MontantTotalSouscriptionData[]|null
     */
    public function getMontantTotalSouscriptionData()
    {
        return isset($this->MontantTotalSouscriptionData) ? $this->MontantTotalSouscriptionData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMontantTotalSouscriptionData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMontantTotalSouscriptionData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMontantTotalSouscriptionDataForArrayConstraintsFromSetMontantTotalSouscriptionData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMontantTotalSouscriptionDataMontantTotalSouscriptionDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfMontantTotalSouscriptionDataMontantTotalSouscriptionDataItem instanceof MontantTotalSouscriptionData) {
                $invalidValues[] = is_object($arrayOfMontantTotalSouscriptionDataMontantTotalSouscriptionDataItem) ? get_class($arrayOfMontantTotalSouscriptionDataMontantTotalSouscriptionDataItem) : sprintf('%s(%s)', gettype($arrayOfMontantTotalSouscriptionDataMontantTotalSouscriptionDataItem), var_export($arrayOfMontantTotalSouscriptionDataMontantTotalSouscriptionDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MontantTotalSouscriptionData property can only contain items of type MontantTotalSouscriptionData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MontantTotalSouscriptionData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param MontantTotalSouscriptionData[] $montantTotalSouscriptionData
     * @return ArrayOfMontantTotalSouscriptionData
     */
    public function setMontantTotalSouscriptionData(array $montantTotalSouscriptionData = array())
    {
        // validation for constraint: array
        if ('' !== ($montantTotalSouscriptionDataArrayErrorMessage = self::validateMontantTotalSouscriptionDataForArrayConstraintsFromSetMontantTotalSouscriptionData($montantTotalSouscriptionData))) {
            throw new \InvalidArgumentException($montantTotalSouscriptionDataArrayErrorMessage, __LINE__);
        }
        if (is_null($montantTotalSouscriptionData) || (is_array($montantTotalSouscriptionData) && empty($montantTotalSouscriptionData))) {
            unset($this->MontantTotalSouscriptionData);
        } else {
            $this->MontantTotalSouscriptionData = $montantTotalSouscriptionData;
        }
        return $this;
    }
    /**
     * Add item to MontantTotalSouscriptionData value
     * @throws \InvalidArgumentException
     * @param MontantTotalSouscriptionData $item
     * @return ArrayOfMontantTotalSouscriptionData
     */
    public function addToMontantTotalSouscriptionData(MontantTotalSouscriptionData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof MontantTotalSouscriptionData) {
            throw new \InvalidArgumentException(sprintf('The MontantTotalSouscriptionData property can only contain items of type MontantTotalSouscriptionData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MontantTotalSouscriptionData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return MontantTotalSouscriptionData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return MontantTotalSouscriptionData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return MontantTotalSouscriptionData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return MontantTotalSouscriptionData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return MontantTotalSouscriptionData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MontantTotalSouscriptionData
     */
    public function getAttributeName()
    {
        return 'MontantTotalSouscriptionData';
    }
}
