<?php
use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPalierPretData ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPalierPretData
 * @subpackage Arrays
 */
class ArrayOfPalierPretData extends AbstractStructArrayBase
{
    /**
     * The PalierPretData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var PalierPretData[]
     */
    public $PalierPretData;
    /**
     * Constructor method for ArrayOfPalierPretData
     * @uses ArrayOfPalierPretData::setPalierPretData()
     * @param PalierPretData[] $palierPretData
     */
    public function __construct(array $palierPretData = array())
    {
        $this
            ->setPalierPretData($palierPretData);
    }
    /**
     * Get PalierPretData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return PalierPretData[]|null
     */
    public function getPalierPretData()
    {
        return isset($this->PalierPretData) ? $this->PalierPretData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPalierPretData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPalierPretData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePalierPretDataForArrayConstraintsFromSetPalierPretData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPalierPretDataPalierPretDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfPalierPretDataPalierPretDataItem instanceof PalierPretData) {
                $invalidValues[] = is_object($arrayOfPalierPretDataPalierPretDataItem) ? get_class($arrayOfPalierPretDataPalierPretDataItem) : sprintf('%s(%s)', gettype($arrayOfPalierPretDataPalierPretDataItem), var_export($arrayOfPalierPretDataPalierPretDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PalierPretData property can only contain items of type PalierPretData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PalierPretData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param PalierPretData[] $palierPretData
     * @return ArrayOfPalierPretData
     */
    public function setPalierPretData(array $palierPretData = array())
    {
        // validation for constraint: array
        if ('' !== ($palierPretDataArrayErrorMessage = self::validatePalierPretDataForArrayConstraintsFromSetPalierPretData($palierPretData))) {
            throw new \InvalidArgumentException($palierPretDataArrayErrorMessage, __LINE__);
        }
        if (is_null($palierPretData) || (is_array($palierPretData) && empty($palierPretData))) {
            unset($this->PalierPretData);
        } else {
            $this->PalierPretData = $palierPretData;
        }
        return $this;
    }
    /**
     * Add item to PalierPretData value
     * @throws \InvalidArgumentException
     * @param PalierPretData $item
     * @return ArrayOfPalierPretData
     */
    public function addToPalierPretData(PalierPretData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof PalierPretData) {
            throw new \InvalidArgumentException(sprintf('The PalierPretData property can only contain items of type PalierPretData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PalierPretData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return PalierPretData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return PalierPretData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return PalierPretData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return PalierPretData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return PalierPretData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PalierPretData
     */
    public function getAttributeName()
    {
        return 'PalierPretData';
    }
}
