<?php
use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProfessionData ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfProfessionData
 * @subpackage Arrays
 */
class ArrayOfProfessionData extends AbstractStructArrayBase
{
    /**
     * The ProfessionData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var ProfessionData[]
     */
    public $ProfessionData;
    /**
     * Constructor method for ArrayOfProfessionData
     * @uses ArrayOfProfessionData::setProfessionData()
     * @param ProfessionData[] $professionData
     */
    public function __construct(array $professionData = array())
    {
        $this
            ->setProfessionData($professionData);
    }
    /**
     * Get ProfessionData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return ProfessionData[]|null
     */
    public function getProfessionData()
    {
        return isset($this->ProfessionData) ? $this->ProfessionData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setProfessionData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProfessionData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProfessionDataForArrayConstraintsFromSetProfessionData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProfessionDataProfessionDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfProfessionDataProfessionDataItem instanceof ProfessionData) {
                $invalidValues[] = is_object($arrayOfProfessionDataProfessionDataItem) ? get_class($arrayOfProfessionDataProfessionDataItem) : sprintf('%s(%s)', gettype($arrayOfProfessionDataProfessionDataItem), var_export($arrayOfProfessionDataProfessionDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ProfessionData property can only contain items of type ProfessionData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ProfessionData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param ProfessionData[] $professionData
     * @return ArrayOfProfessionData
     */
    public function setProfessionData(array $professionData = array())
    {
        // validation for constraint: array
        if ('' !== ($professionDataArrayErrorMessage = self::validateProfessionDataForArrayConstraintsFromSetProfessionData($professionData))) {
            throw new \InvalidArgumentException($professionDataArrayErrorMessage, __LINE__);
        }
        if (is_null($professionData) || (is_array($professionData) && empty($professionData))) {
            unset($this->ProfessionData);
        } else {
            $this->ProfessionData = $professionData;
        }
        return $this;
    }
    /**
     * Add item to ProfessionData value
     * @throws \InvalidArgumentException
     * @param ProfessionData $item
     * @return ArrayOfProfessionData
     */
    public function addToProfessionData(ProfessionData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof ProfessionData) {
            throw new \InvalidArgumentException(sprintf('The ProfessionData property can only contain items of type ProfessionData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ProfessionData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return ProfessionData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return ProfessionData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return ProfessionData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return ProfessionData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return ProfessionData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProfessionData
     */
    public function getAttributeName()
    {
        return 'ProfessionData';
    }
}
