<?php
use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSurprimeData ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSurprimeData
 * @subpackage Arrays
 */
class ArrayOfSurprimeData extends AbstractStructArrayBase
{
    /**
     * The SurprimeData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var SurprimeData[]
     */
    public $SurprimeData;
    /**
     * Constructor method for ArrayOfSurprimeData
     * @uses ArrayOfSurprimeData::setSurprimeData()
     * @param SurprimeData[] $surprimeData
     */
    public function __construct(array $surprimeData = array())
    {
        $this
            ->setSurprimeData($surprimeData);
    }
    /**
     * Get SurprimeData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return SurprimeData[]|null
     */
    public function getSurprimeData()
    {
        return isset($this->SurprimeData) ? $this->SurprimeData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSurprimeData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSurprimeData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSurprimeDataForArrayConstraintsFromSetSurprimeData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSurprimeDataSurprimeDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfSurprimeDataSurprimeDataItem instanceof SurprimeData) {
                $invalidValues[] = is_object($arrayOfSurprimeDataSurprimeDataItem) ? get_class($arrayOfSurprimeDataSurprimeDataItem) : sprintf('%s(%s)', gettype($arrayOfSurprimeDataSurprimeDataItem), var_export($arrayOfSurprimeDataSurprimeDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SurprimeData property can only contain items of type SurprimeData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SurprimeData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param SurprimeData[] $surprimeData
     * @return ArrayOfSurprimeData
     */
    public function setSurprimeData(array $surprimeData = array())
    {
        // validation for constraint: array
        if ('' !== ($surprimeDataArrayErrorMessage = self::validateSurprimeDataForArrayConstraintsFromSetSurprimeData($surprimeData))) {
            throw new \InvalidArgumentException($surprimeDataArrayErrorMessage, __LINE__);
        }
        if (is_null($surprimeData) || (is_array($surprimeData) && empty($surprimeData))) {
            unset($this->SurprimeData);
        } else {
            $this->SurprimeData = $surprimeData;
        }
        return $this;
    }
    /**
     * Add item to SurprimeData value
     * @throws \InvalidArgumentException
     * @param SurprimeData $item
     * @return ArrayOfSurprimeData
     */
    public function addToSurprimeData(SurprimeData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof SurprimeData) {
            throw new \InvalidArgumentException(sprintf('The SurprimeData property can only contain items of type SurprimeData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SurprimeData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return SurprimeData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return SurprimeData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return SurprimeData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return SurprimeData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return SurprimeData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SurprimeData
     */
    public function getAttributeName()
    {
        return 'SurprimeData';
    }
}
