<?php
use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTauxAssurePret ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTauxAssurePret
 * @subpackage Arrays
 */
class ArrayOfTauxAssurePret extends AbstractStructArrayBase
{
    /**
     * The TauxAssurePret
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var TauxAssurePret[]
     */
    public $TauxAssurePret;
    /**
     * Constructor method for ArrayOfTauxAssurePret
     * @uses ArrayOfTauxAssurePret::setTauxAssurePret()
     * @param TauxAssurePret[] $tauxAssurePret
     */
    public function __construct(array $tauxAssurePret = array())
    {
        $this
            ->setTauxAssurePret($tauxAssurePret);
    }
    /**
     * Get TauxAssurePret value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return TauxAssurePret[]|null
     */
    public function getTauxAssurePret()
    {
        return isset($this->TauxAssurePret) ? $this->TauxAssurePret : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTauxAssurePret method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTauxAssurePret method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTauxAssurePretForArrayConstraintsFromSetTauxAssurePret(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTauxAssurePretTauxAssurePretItem) {
            // validation for constraint: itemType
            if (!$arrayOfTauxAssurePretTauxAssurePretItem instanceof TauxAssurePret) {
                $invalidValues[] = is_object($arrayOfTauxAssurePretTauxAssurePretItem) ? get_class($arrayOfTauxAssurePretTauxAssurePretItem) : sprintf('%s(%s)', gettype($arrayOfTauxAssurePretTauxAssurePretItem), var_export($arrayOfTauxAssurePretTauxAssurePretItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TauxAssurePret property can only contain items of type TauxAssurePret, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TauxAssurePret value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param TauxAssurePret[] $tauxAssurePret
     * @return ArrayOfTauxAssurePret
     */
    public function setTauxAssurePret(array $tauxAssurePret = array())
    {
        // validation for constraint: array
        if ('' !== ($tauxAssurePretArrayErrorMessage = self::validateTauxAssurePretForArrayConstraintsFromSetTauxAssurePret($tauxAssurePret))) {
            throw new \InvalidArgumentException($tauxAssurePretArrayErrorMessage, __LINE__);
        }
        if (is_null($tauxAssurePret) || (is_array($tauxAssurePret) && empty($tauxAssurePret))) {
            unset($this->TauxAssurePret);
        } else {
            $this->TauxAssurePret = $tauxAssurePret;
        }
        return $this;
    }
    /**
     * Add item to TauxAssurePret value
     * @throws \InvalidArgumentException
     * @param TauxAssurePret $item
     * @return ArrayOfTauxAssurePret
     */
    public function addToTauxAssurePret(TauxAssurePret $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof TauxAssurePret) {
            throw new \InvalidArgumentException(sprintf('The TauxAssurePret property can only contain items of type TauxAssurePret, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TauxAssurePret[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return TauxAssurePret|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return TauxAssurePret|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return TauxAssurePret|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return TauxAssurePret|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return TauxAssurePret|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TauxAssurePret
     */
    public function getAttributeName()
    {
        return 'TauxAssurePret';
    }
}
